/***
 * 
 * @author jeffreysmith
 * 
 * v1.0 November 2012
 * 
 * a basic data structure to store geo coords of a city
 * 
 */

public class MPCityItem {

	private String city_name;
	public float city_lat;
	public float city_long;
	
	private int skipSpaces(String[] tokens, int i)
	{
	    while (i < tokens.length) {
	    	if (!tokens[i].contentEquals("") && !tokens[i].contentEquals(" ")) {
	    		break;
	    	}
	    	i++;
	    }
		return i;
	}
	
	/***
	 *  read city information from a string
	 * @param s:  city name \t longitude \t latitude <\t density>
	 */
	public MPCityItem(String s)
	{
	    String[] tokens = s.split("\t");
	    
	    int i = 0;
	    city_name = tokens[i];
	    i = skipSpaces(tokens, ++i);
	    city_long = Float.parseFloat(tokens[i]);
	    i = skipSpaces(tokens, ++i);
	    city_lat = Float.parseFloat(tokens[i]);
	    
	    // System.out.println(city_name + "\t" + city_long + "\t" + city_lat);
	}
	
	public MPCityItem(float n_lat, float n_long)
	{
		city_lat = n_lat;
		city_long = n_long;
	}
	
	public MPCityItem(float n_lat, float n_long, String name)
	{
		city_name = name;
		city_lat = n_lat;
		city_long = n_long;
	}
	
	public boolean isDublin()
	{
		return city_name != null && city_name.equalsIgnoreCase("dublin");
	}
	
	public boolean isRiga()
	{
		return city_name != null && city_name.equalsIgnoreCase("riga");
	}
	
	public static String nullString()
	{
		return "null";
	}
	
	public boolean isNull()
	{
		return city_name == null || city_name.equals(nullString());
	}
	
	public String GetName()
	{
		return city_name;
	}
	
	public boolean RadiusMatch(MPCityItem item)
	{
		float dx = city_long - item.city_long;
		float dy = city_lat - item.city_lat;
		
		double radius = Math.sqrt(dx * dx + dy * dy);
		
		// System.out.print(" " + radius + " ");
		return radius < 0.35;
	}

}
