import java.util.ArrayList;
import java.util.Collections;

public class MPExperts {
	
	public class MPExpertItem implements Comparable<MPExpertItem>  {
		protected String region = null;
		protected int experts = 0;
		protected int amateurs = 0;
		
		public MPExpertItem(String reg, int exp, int amat)
		{
			region = reg;
			experts = exp;
			amateurs = amat;
		}
		
		public int compareTo(MPExpertItem inst)
		{
			int result = region.compareTo(inst.region);
			return result;
		}
		
	}
		
	ArrayList<MPExpertItem> expertList = null;
	
	public MPExperts()
	{
		expertList = new ArrayList<MPExpertItem>();
	}
	
	public void AddExpert(String region)
	{
		MPExpertItem item = new MPExpertItem(region, 1, 0);
		Add(item);
	}

	public void AddAmateur(String region)
	{
		MPExpertItem item = new MPExpertItem(region, 0, 1);
		Add(item);
	}

	public void Add(MPExpertItem item)
	{
		int index = Collections.binarySearch(expertList, item);
		if (index >= 0) {
			MPExpertItem match = expertList.get(index);
			match.experts += item.experts;
			match.amateurs += item.amateurs;
		} else {
			expertList.add(-index - 1, item);
		}
	}

	public void Merge(MPExperts list2)
	{
		if (list2 == null) {
			return;
		}
		
		for (MPExpertItem item : list2.expertList) {
			Add(item);
		}
	}
	
	public int GetSize()
	{
		return expertList.size();
	}
	
	public int GetExpertCount(String region)
	{
		MPExpertItem key = new MPExpertItem(region, 0, 0);
		int index = Collections.binarySearch(expertList, key);
		if (index < 0) {
			return 0;
		}
		
		MPExpertItem match = expertList.get(index);
		return match.experts;
	}
	
	public int GetTotalCount(String region)
	{
		MPExpertItem key = new MPExpertItem(region, 0, 0);
		int index = Collections.binarySearch(expertList, key);
		if (index < 0) {
			return 0;
		}
		
		MPExpertItem match = expertList.get(index);
		return match.experts + match.amateurs;
			
	}
	
}
