import java.io.File;
import java.util.ArrayList;

	public class MPFileDriver {
		
		public ArrayList<String> filepaths = new ArrayList<String>();
		
		/*
		 * return true if nested
		 */
		
		private boolean addPaths(File dir)
		{
			boolean nested = false;
			if (dir.isDirectory()) {
				String[] directoryItems = dir.list();
				for (int i = 0; i < directoryItems.length; i++) {
					String directoryItem = directoryItems[i];
	
					// determine path for new item
					String newPath = dir.getPath() + File.separator + directoryItem;
	
					File fileItem = new File(newPath);
					if ( fileItem.isDirectory() && !fileItem.isHidden() && !newPath.endsWith("bak")) {
						nested = addPaths(fileItem) || nested;
					}
				}
			}
			
			if (!nested) {
				filepaths.add(dir.getPath());
				System.out.println(dir.getPath());
				nested = true;
			}
			return nested;
		}
		
		public MPFileDriver(String path)
		{
			MPTxtReader txrdr = new MPTxtReader(path);
			String buffer = txrdr.MPReadTxtLn();
			if (buffer == null || buffer.isEmpty()) {
				System.err.println("error:  file driver null " + path);
				return;
			}
			
			do {
				// check for comment
				if (buffer.charAt(0) != '#') {
					addPaths(new File(buffer));
				}
				buffer = txrdr.MPReadTxtLn();
			} while (buffer != null && !buffer.isEmpty());
			
			txrdr.Close();
		}
		
	}

