import java.io.FileReader;
import java.util.ArrayList;

import com.amazonaws.util.json.JSONObject;
import com.amazonaws.util.json.JSONArray;
import com.amazonaws.util.json.JSONException;
import com.amazonaws.util.json.JSONTokener;

public class MPJson {
	
	private JSONObject json;
	private FileReader jsonReader;
	private JSONTokener jsonTokener;
	
	public MPJson()
	{
	}
	
	public boolean MPJsonOpenString(String s)
	{
		jsonTokener = new JSONTokener(s);
		try {
			json = new JSONObject(jsonTokener);
		} catch (JSONException e) {
			e.printStackTrace();
			return false;
		}
		
		return true;
	}
	
	public boolean MPJsonOpenFile(String path)
	{
		try {
			jsonReader = new FileReader(path);
		} catch (Exception e) {
			return false;
		}
		
		jsonTokener = new JSONTokener(jsonReader);
		try {
			json = new JSONObject(jsonTokener);
		} catch (JSONException e) {
			e.printStackTrace();
			return false;
		}
		
		return true;
	}
	
	public boolean MPJsonCloseFile()
	{
		try {
			if (jsonReader != null) {
				jsonReader.close();
			}
		} catch (Exception e) {
			return false;
		}
		return true;
	}
	
	public String MPJsonGetString(String index)
	{
		if (json == null || json.isNull(index)) {
			return null;
		}
		
		String result = null;
		try {
			result = json.getString(index);
		} catch (JSONException e) {
			e.printStackTrace();
		}
		return result;
	}
	
	public boolean MPJsonGetBoolean(String index)
	{
		if (json == null || json.isNull(index)) {
			return false;
		}
		
		boolean result = false;
		try {
			result = json.getBoolean(index);
		} catch (JSONException e) {
			e.printStackTrace();
			result = false;
		}
		return result;
	}

	public JSONArray MPJsonGetArr(String index)
	{
		if (json == null || json.isNull(index)) {
			return null;
		}
		
		JSONArray ar = null;
		try {
			ar = json.getJSONArray(index);
		} catch (JSONException e) {
			e.printStackTrace();
		}
		
		return ar;
	}
		
	public ArrayList<String> MPJsonGetStringArray(String index) 
	{
		ArrayList<String> stringarr = new ArrayList<String>(0);
		JSONArray ar = MPJsonGetArr(index);
		if (ar != null) {
			try {
				for (int i = 0; i < ar.length(); i++) {
					stringarr.add(ar.getString(i));
				}
			} catch (JSONException e) {
				stringarr = null;
			}
			
		}
		return stringarr;
	}
	
	public int[] MPJsonGetIntArray(String index) 
	{
		int intarr[] = null;
		JSONArray ar = MPJsonGetArr(index);
		if (ar != null) {
			try {
				intarr = new int[ar.length()];
				int i = 0;
				for (; i < ar.length(); i++) {
					intarr[i] = ar.getInt(i);
				}
			} catch (JSONException e) {
				intarr = null;
			}
			
		}
		return intarr;
	}
	
	public ArrayList<Integer> MPJsonGetIntList(String index) 
	{
		ArrayList<Integer> alist = null;
		JSONArray ar = MPJsonGetArr(index);
		if (ar != null) {
			try {
				alist = new ArrayList<Integer>(ar.length());
				int i = 0;
				for (; i < ar.length(); i++) {
					alist.add(i, ar.getInt(i));
				}
			} catch (JSONException e) {
				alist = null;
			}
		}
		return alist;
	}
	
	public int MPJsonGetInt(String index) 
	{
		if (json == null || json.isNull(index)) {
			return 0;
		}
		
		int i = 0;
		try {
			i = json.getInt(index);
		} catch (JSONException e) {
			e.printStackTrace();
		}
		return i;
	}

	public double MPJsonGetDouble(String index) 
	{
		if (json == null || json.isNull(index)) {
			return 0.0;
		}
		
		double d = 0;
		try {
			d = json.getDouble(index);
		} catch (JSONException e) {
			e.printStackTrace();
		}
		return d;
	}
}
