
/****
 * 
 * @author jeffreysmith
 * 
 * nov 2012
 * 
 * @revision 1.1 rewrite cache to store to disk; requires change of indexes to performance file name (which is unique)
 * 
 * cache of performance cluster items.  these guys are computationally expensive, and so
 * we only want to compute them once.
 *
 */
public class MPPerfClusterCache {
	
	float [][] the_cache;
	
	/*
	private short readCache(ObjectInputStream ois)
	{
		short result = 0;
		
		try {
			
			the_cache = (TreeMap<String, MPPerfClusterItem>)ois.readObject();
			
		} catch (IOException e) {
			System.out.println("IO exception " + e);
			result = -1;
			
		} catch (ClassNotFoundException e) {
			System.out.println("Class not found exception " + e);
			result = -1;
		}
		
		return result;
	}

	private short ReadClusterCache()
	{
		short result = -1;
		
		File cachefile = new File(cachefilename);
		if (cachefile.exists()) {
			try {
				FileInputStream fis = new FileInputStream(cachefile);
				ObjectInputStream ois = new ObjectInputStream(fis);
				result = readCache(ois);
				ois.close();
			} catch (FileNotFoundException e) {
				System.err.println("File Not Found exception " + e);
			} catch (IOException e) {
				System.err.println("IO exception " + e);
			}
		}
		
		if (result != 0) {
			the_cache = new TreeMap<String, MPPerfClusterItem>();
		} else {
			System.out.println("cluster cache read " + the_cache.size());
		}
		
		return result;
	}	
	
	private short writeCache(ObjectOutputStream oos)
	{
		short result = 0;
		try {
			oos.writeObject(the_cache);
			
		} catch (IOException e) {
			result = -1;
			System.out.println("writeCache: IO exception " + e);			
		}
		
		return result;
	}
	
	private short WriteClusterCache()
	{
		if (!cache_dirty) {
			return 0;
		}
		
		short result = -1;
		// load meta data from file
		try {
			File cachefile = new File(cachefilename);
			FileOutputStream fos = new FileOutputStream(cachefile);
			ObjectOutputStream oos = new ObjectOutputStream(fos);
			result = writeCache(oos);
			oos.close();
		} catch (FileNotFoundException e) {
			System.out.println("File Not Found exception " + e);
		} catch (IOException e) {
			System.out.println("IO exception " + e);
		}
		
		if (result == 0) {
			cache_dirty = false;
		}
		
		return result;
	}
	*/
	
	
	MPPerfClusterCache(int size) 
	{
		the_cache = new float[size][size];
		// cachefilename = name;
		// ReadClusterCache();
	}
	
	public void StoreCache()
	{
		// WriteClusterCache();
	}
	
	protected void Clear()
	{
		the_cache = null;
	}
	
	/*
	// static char[] buffer = new char[100];
	
	protected String getKey(MPPerformance x, MPPerformance y)
	{
		// unique ids are initially strings of HEX values; plenty of space in unicode,
		// and this data structure can be HUGE so space at premium
		String xs = x.getUniqueID();
		String ys = y.getUniqueID();
		for (int i = 0; i < xs.length(); i++) {
			buffer[i] = (char)(xs.charAt(i) + ys.charAt(i));
		}
		xs = new String(buffer, 0, xs.length());
		return xs;
	}
	*/
	
	protected void add(MPPerformance i, MPPerformance j, float r)
	{
		// hack to save storage
		if (r == 0.0f) {
			r = 0.00000001f;
		}
		int a = Math.min(i.getUniqueID2(), j.getUniqueID2());
		int b = Math.max(i.getUniqueID2(), j.getUniqueID2());
		the_cache[a][b] = r;
	}
	
	protected boolean exists(MPPerformance i, MPPerformance j)
	{
		int a = Math.min(i.getUniqueID2(), j.getUniqueID2());
		int b = Math.max(i.getUniqueID2(), j.getUniqueID2());
		return the_cache[a][b] != 0f;
	}
	
	protected float get(MPPerformance i, MPPerformance j)
	{
		int a = Math.min(i.getUniqueID2(), j.getUniqueID2());
		int b = Math.max(i.getUniqueID2(), j.getUniqueID2());
		return the_cache[a][b];
	}
}
