import java.io.Serializable;
import java.util.*;

/***
 * 
 * @author jeffsmith
 *
 * two performances (x, y) and their pearson & spearman correlations (r)
 */
public class MPPerfClusterItem implements Serializable, Comparable<MPPerfClusterItem>  {

	/** Version UID */
	public static final long serialVersionUID = 1;

	public static int multiplier = Integer.MAX_VALUE / 100;

	public float rPearson;
	
	public MPPerfClusterItem(float r, float s)
	{
		rPearson = r;
	}
	
	
	public int compareTo(MPPerfClusterItem item)
	{
		// sort in descending order
		double f = item.rPearson - rPearson;
		return (int)Math.round(f * MPPerfClusterItem.multiplier);
	}
}

class MPPerfClusterItemUniqueIndexComparator implements Comparator<MPPerfClusterItem> 
{
    public int compare(MPPerfClusterItem ci1, MPPerfClusterItem ci2) 
    {
    	// under construction
        return 0;
    }
}


class MPPerfClusterItemPearsonComparator implements Comparator<MPPerfClusterItem> 
{
    public int compare(MPPerfClusterItem ci1, MPPerfClusterItem ci2) 
    {
		// sort in descending order
		double d = ci2.rPearson - ci1.rPearson;
		// if (d == 0) {
		// 	d = ci2.rSpearman - ci1.rSpearman;
		// }
		return (int)Math.round(d * MPPerfClusterItem.multiplier);
    }
}

class MPPerfClusterItemSpearmanComparator implements Comparator<MPPerfClusterItem> 
{
    public int compare(MPPerfClusterItem ci1, MPPerfClusterItem ci2) 
    {
		// sort in descending order
    	double d;
		// d = ci2.rSpearman - ci1.rSpearman;
		// if (d == 0) {
			d = ci2.rPearson - ci1.rPearson;
		// }
		return (int)Math.round(d * MPPerfClusterItem.multiplier);
    }
}
