import java.text.DateFormat;
import java.util.*;

/***
 * 
 * @author jeffreyniusmith
 *
 * @version 1.0 August 2012
 * 
 * This helper class manages performance dates and times.  
 * 
 */

public class MPPerfDate {
	Calendar perfCal = Calendar.getInstance(); 
	
	public void Set(Calendar theDate)
	{
		perfCal = theDate;
	}
	
	public void Set(Date theDate)
	{
		perfCal.setTime(theDate);
	}
	
	public MPPerfDate()
	{
	}
	
	public MPPerfDate(Calendar theDate)
	{
		Set(theDate);
	}
	
	public MPPerfDate(Date theDate)
	{
		Set(theDate);
	}
	
	public String getString()
	{
		  DateFormat df = DateFormat.getDateInstance();
		  String s = df.format(perfCal.getTime());
		  return s;
	}
	
	protected long getTimeinMS()
	{
		return perfCal.getTimeInMillis();
	}
	
	public int compareTo(MPPerfDate d)
	{
		return perfCal.compareTo(d.perfCal);
	}
	
	protected int getHour()
	{
		int theHour = perfCal.get(Calendar.HOUR_OF_DAY);
		return theHour;
	}
	
	public boolean isNight()
	{
		return getHour() >= 22 || getHour() < 6;
	}
	
	public boolean isMorning()
	{
		return getHour() >= 6 && getHour() < 12;
	}

	public boolean isAfternoon()
	{
		return getHour() >= 12 && getHour() < 17;
	}

	public boolean isEvening()
	{
		return getHour() >= 17 && getHour() < 22;
	}	
	
	public int hourIndex()
	{
		int index = 0;
		if (isNight()) {
			index = 0;
		} else if (isMorning()) {
			index = 1;
		} else if (isAfternoon()) {
			index = 2;
		} else if (isEvening()) {
			index = 3;
		} else {
			System.out.println("error:  MPPrefDate:  hourIndex");
		}
		return index;
	}
	
	static public String hourIndexToString(int i)
	{
		String s = "";
		switch (i) {
		case 0:
			s = "Night";
			break;
		case 1:
			s = "Morning";
			break;
		case 2:
			s = "Afternoon";
			break;
		case 3:
			s = "Evening";
			break;
		default:
			System.out.println("error:  MPPrefDate:  IndexToString");
			break;
		}
		return s;
	}
}
