import java.util.ArrayList;
import java.util.Collections;

public class MPPerfQuadrants {
	
	public class Quads {
		protected int the_quads[];
	
		public Quads(int quad)
		{
			the_quads = new int[5];
			for (int i = 0; i < 5; i++) {
				the_quads[i] = 0;
			}
			the_quads[quad]++;
		}
		
		public Quads(int quads[])
		{
			the_quads = quads;
		}
		
		public void Add(Quads q)
		{
			for (int i = 1; i < 5; i++) {
				the_quads[i] += q.the_quads[i];
			}
		}
		
		public void Report(MPOutputStream out)
		{	
			int sum = 0;
			for (int i = 1; i < 5; i++) {
				sum += the_quads[i];
			}
			for (int i = 1; i < 5; i++) {
				out.MPWrite(the_quads[i] / (float)sum + "\t");
			}
		}
	}
	
	public class MPPerfQuadItem implements Comparable<MPPerfQuadItem>  {
		protected String region;
		protected Quads quads;
		
		public MPPerfQuadItem(String reg, int quad)
		{
			region = reg;
			quads = new Quads(quad);
		}

		public MPPerfQuadItem(String reg, int qs[])
		{
			region = reg;
			quads = new Quads(qs);
		}
		
		public void Add(MPPerfQuadItem item)
		{
			quads.Add(item.quads);
		}
		
		public int compareTo(MPPerfQuadItem inst)
		{
			int result = region.compareTo(inst.region);
			return result;
		}
		
	}
		
	ArrayList<MPPerfQuadItem> quadList = null;
	
	public MPPerfQuadrants()
	{
		quadList = new ArrayList<MPPerfQuadItem>();
	}
	
	public void Add(String region, int quad)
	{
		MPPerfQuadItem item = new MPPerfQuadItem(region, quad);
		Add(item);
	}

	public void Add(MPPerfQuadItem item)
	{
		int index = Collections.binarySearch(quadList, item);
		if (index >= 0) {
			MPPerfQuadItem match = quadList.get(index);
			match.Add(item);
		} else {
			quadList.add(-index - 1, item);
		}
	}

	public void Merge(MPPerfQuadrants list2)
	{
		for (MPPerfQuadItem item : list2.quadList) {
			Add(item);
		}
	}
	
	public int GetSize()
	{
		return quadList.size();
	}
	
	public Quads GetQuadInfo(String region)
	{
		MPPerfQuadItem key = new MPPerfQuadItem(region, 0);
		int index = Collections.binarySearch(quadList, key);
		if (index < 0) {
			return null;
		}
		
		MPPerfQuadItem match = quadList.get(index);
		return match.quads;
	}
	
}
