import java.util.*;

/***
 * 
 * @author jeffsmith
 *
 * nov 1st 2012
 * 
 * 
 */
public class MPRegionPair implements Comparable<MPRegionPair>  {

	protected RIRegionItem region1;
	protected int region1size;
	protected RIRegionItem region2;
	protected int region2size;
	protected float pearson;
	
	static int cnt = 0;
	static int sumcnt = 0;
	public MPRegionPair(RIRegionItem a, int asize, RIRegionItem b, int bsize, float rPearson)
	{
		/*
		String teststr = "42.0,-88.0";
		if (a.GetRegionName().equals(teststr) || (b != null && b.GetRegionName().equals(teststr))) {
			System.out.print(a.GetRegionName() + " " + asize + " ");
			if (b != null) {
				System.out.print(b.GetRegionName() + " " + bsize + " ");
			}
			System.out.print(pearson_index + " ");
			System.out.println(++cnt);
			if (b == null) {
				sumcnt += asize;
				System.out.println("Sum " + sumcnt);
			}
		}*/

		region1 = a;
		region1size = asize;
		region2 = b;
		region2size = bsize;
		pearson = rPearson;
		// System.out.println(a.GetRegionName() + ", " + ((b != null) ? b.GetRegionName() : ""));
	}
		
	public int compareTo(MPRegionPair item)
	{
		// descending order
		int a = Integer.MAX_VALUE / 4;
		return (int)Math.round(item.pearson * a - pearson * a);
	}
	
	public int compareToStrings(MPRegionPair item)
	{
    	int result = region1.GetRegionName().compareTo(item.region1.GetRegionName());
    	if (result == 0) {
    		result = region2.GetRegionName().compareTo(item.region2.GetRegionName());
    	}
    	return result;
	}
	
	public float GetPearson()
	{
		return pearson;
	}
	
	public String GetString()
	{
		String s = region1.GetRegionName() + "\t" + region1size + "\t" + region2.GetRegionName() + "\t" + region2size + "\t" + pearson;
		return s;
	}
	
	static protected String OutputFormat()
	{
		return "region1\tsize\tregion2\tsize\t\rank";
	}
}

class MPRegionPairComparator implements Comparator<MPRegionPair> 
{
	// compare both strings:  region1 and region2
    public int compare(MPRegionPair ci1, MPRegionPair ci2) 
    {
    	return ci1.compareToStrings(ci2);
    }
}

class MPRegionPair1Comparator implements Comparator<MPRegionPair> 
{
	// only compare string region1
    public int compare(MPRegionPair ci1, MPRegionPair ci2) 
    {
    	return ci1.region1.compareTo(ci2.region1);
    }
}

class MPRegionPairValueInvertComparator implements Comparator<MPRegionPair>
{
	// compare the values
    public int compare(MPRegionPair ci1, MPRegionPair ci2) 
    {
    	return ci2.compareTo(ci1);
    }	
}

class MPRegionPairValueComparator implements Comparator<MPRegionPair> 
{
	// compare the values
    public int compare(MPRegionPair ci1, MPRegionPair ci2) 
    {
    	return ci1.compareTo(ci2);
    }
}

