import java.util.*;

/***
 * 
 * @author jeffsmith
 *
 * aug 26th 2012
 * 
 * class to store a spearman item to enable his ranking algorithm
 * 
 * http://en.wikipedia.org/wiki/Spearman%27s_rank_correlation_coefficient
 * 
 */
public class MPSpearmanItem implements Comparable<MPSpearmanItem>  {

	public long xDur;
	public long yDur;
	
	public short xRank;
	public short yRank;
	
	public MPSpearmanItem(long x, long y)
	{
		xDur = x;
		yDur = y;
	}
	
	public void SetXRank(short x)
	{
		xRank = x;
	}
	
	public void SetYRank(short y)
	{
		yRank = y;
	}
	
	public int compareTo(MPSpearmanItem item)
	{
		// descending order
		return (int)(item.xDur - xDur);
	}
	
	public String GetString()
	{
		String s = xDur + "\t" + yDur + "\t" + xRank + "\t" + yRank + "\t";
		return s;
	}
	
	static protected String OutputFormat()
	{
		return "x\ty\tx rank\tyrank\t";
	}
}

class MPSpearmanItemXComparator implements Comparator<MPSpearmanItem> 
{
    public int compare(MPSpearmanItem ci1, MPSpearmanItem ci2) 
    {
		// descending order
		return (int)(ci2.xDur - ci1.xDur);
    }
}

class MPSpearmanItemYComparator implements Comparator<MPSpearmanItem> 
{
    public int compare(MPSpearmanItem ci1, MPSpearmanItem ci2) 
    {
		// descending order
		return (int)(ci2.yDur - ci1.yDur);
    }
}

