import java.io.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

/***
 * 
 * @author jeffreysmith
 * 
 * v1.0 November 2012
 * 
 * a wrapper to simplify and abstract reading text
 * 
 */


public class MPTxtReader {

	boolean file_exists;
	BufferedReader br;
	
	public MPTxtReader(String path)
	{
		File the_file = new File(path);
		if (!the_file.exists()) {
			System.err.println("TxtReader file not found " + path);
			return;
		}
		
		try {
			br = new BufferedReader(new FileReader(the_file));
			file_exists = true;
		} catch (IOException e) {
			System.err.println("Error: " + e);
		}
	}
	
	public boolean FileExists()
	{
		return file_exists;
	}
	
	public void Close()
	{
		try {
			br.close();
		} catch (IOException e) {
			System.err.println("Error: " + e);
		}
	}
	
	public String MPReadTxtLn()
	{
		String thisLine = null;
		
		if (file_exists) {
			try {
				thisLine = br.readLine();
			} catch (IOException e) {
			       System.err.println("Error: " + e);
			}
		}
		
		return thisLine;
	}
	
	public static int ParseInteger(String s)
	{
		// integer is in quotes:  "123"
		s = s.substring(1, s.length()-1);
		
		int p = 0;
		// check for NULL
		if (!s.equalsIgnoreCase("NULL")) {
			 p = Integer.parseInt(s);
		}
		return p;
	}
	
	public static long ParseLong(String s)
	{
		// integer is in quotes:  "123"
		s = s.substring(1, s.length()-1);
		
		long p = 0;
		// check for NULL
		if (!s.equalsIgnoreCase("NULL")) {
			 p = Long.parseLong(s);
		}
		return p;
	}
		
	public static String ParseString(String s)
	{
		String str = s.substring(1, s.length()-1);
		return str;
	}
	    
	public static Calendar DateFromString(String s) 
	{
		Calendar date = Calendar.getInstance();

		try {
			SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
			Date datestr = formatter.parse(s);
			date.setTime(datestr);
		} catch (ParseException e) {
			System.err.println(e);
		}

		return date;
	}
	    

}
