public class RIStateRegionItem extends RIRegionItem {

	public RIStateRegionItem(MPGeoCoord2 coord) 
	{
		super();
		if (!coord.isState()) {
			System.err.println("RIStateRegionItem:  not state");
		}
		region_name = MPGeoCoord2.MapStateName(coord.getState());
	}
	
	static public String GetKey(MPGeoCoord2 coord) 
	{
		return MPGeoCoord2.MapStateName(coord.getState());
	}
	
	public boolean Contains(MPGeoCoord2 geocoord)
	{
		String key = GetKey(geocoord);
		if (key != null) {
			if (region_name.compareTo(key) == 0) {
				return true;
			}
		}
		return false;
	}

	public boolean Contains(MPGeoCoord2 loc, double scale)
	{
		return Contains(loc);
	}
}
